/***********************************************************
 * tiutiu License ver.1.0.   see http://tiutiu.net/license/
 * Copyright(c) 2009, tiutiu.net all rights reserved.
 * 1. ۏ؂ƍ҂͐ӔC𕉂ȂƂ̏B
 * 2. hɂ͌̒쌠Ƌɖ{CZX̎gp/B
 * 3. 1,2ɔȂp𖳏ŋB
//*********************************************************/

#include "tiuwindow.h"
#include "windows.h"

HWND  hWnd = NULL;
HFONT hFontDefault = NULL;

LRESULT CALLBACK tiuWindowProc(HWND hwnd,
							   UINT uMsg,
							   WPARAM wParam,
							   LPARAM lParam);
							   

/* ă[vɓ֐ */
int tiuWindow(void) {
  tiuWindowStart();
  tiuWindowLoop();
  tiuWindowEnd();

  return TIU_OK;

} /* tiuWindow */


/* tHg̍쐬,  */
int tiuWindowStart( void ) {

  // tHg̍쐬
  // http://msdn.microsoft.com/en-us/library/ms534214.aspx
  hFontDefault = CreateFont( 16, // 
							 8,  // ς̕
							 0,  // ]̊px
							 0,  // ]̒S
							 FW_NORMAL,  // ̑/FW_NORMAL=400
							 0,  // Α=no
							 0,  // =no
							 0,  // =no
							 DEFAULT_CHARSET, // Zbg=ftHg
							 OUT_DEFAULT_PRECIS,  // o͐x
							 CLIP_DEFAULT_PRECIS,  // NbsOx
							 DEFAULT_QUALITY, // A`GCAXƂ
							 DEFAULT_PITCH | FF_MODERN,   // Ԋu
							 "lr o SVbN" ); // tHg

  // ̍쐬
  WNDCLASSEX wc;

  wc.cbSize        = sizeof(WNDCLASSEX);
  wc.lpszClassName = "tiuWindow";
  wc.lpszMenuName  = "tiuWindow";
  wc.hInstance     = GetModuleHandle(NULL);
  wc.lpfnWndProc   = tiuWindowProc;
  wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
  wc.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
  wc.style         = CS_HREDRAW | CS_VREDRAW;
  wc.cbClsExtra    = 0;
  wc.cbWndExtra    = 0;
  if(!RegisterClassEx(&wc)) return 0;   // EBhENX̓o^Ɏs

  /* ł͑쐬܂傤! */
  hWnd = CreateWindow (wc.lpszClassName,
					   "tiuWindow",
					   WS_OVERLAPPEDWINDOW,
					   CW_USEDEFAULT,   /* 쐬̉ʍ̈ʒu */
					   CW_USEDEFAULT,   /* 쐬̉ʏ̈ʒu */
					   200,             /* ̕   */
					   200,             /* ̍ */
					   (HWND)NULL,
					   (HMENU)NULL,
					   wc.hInstance,
					   (LPVOID)NULL
					   );

  if( hWnd==NULL )  return 0;
  // MessageBox( NULL, "CreateWindow", "CreateWindow", MB_OK );

  /* ͍ŏ͉BĂ̂ł\ */
  ShowWindow(hWnd, SW_SHOW);
  
  return TIU_OK;
}


/* tHǧЕt */
int tiuWindowEnd( void ) {
  DeleteObject( hFontDefault );
  return TIU_OK;
}

/* [vɓ */
int tiuWindowLoop( void ) {

  /* ݂Ȃ̖߂󂯕t */
  MSG msg;
  while(GetMessage(&msg, NULL, 0, 0)) {
	TranslateMessage( &msg );
	DispatchMessage( &msg );
  }

  return TIU_OK;
}


/* 𐧌䂷֐ */
LRESULT CALLBACK tiuWindowProc(HWND hwnd,
							   UINT message,
							   WPARAM wparam,
							   LPARAM lparam) { 
  switch( message ) {
	//case WM_CREATE:
	//tiuButton();
	//break;
  case WM_DESTROY:
	PostQuitMessage( 0 );
	break;
  default:
	return DefWindowProc(hwnd,message,wparam,lparam);
  }
  
  return FALSE;
} /* tiuWindowProc */


/* tiuWindow̃EBhEnh */
HWND tiuHwnd( void ) {
  return hWnd;
}


/* {^ǉ */
int tiuButton( void ) {
  HWND hWndBtn = NULL;
  if( hWnd == NULL ) {
	// MessageBox( hWnd, "", "HWNDNULLłB", MB_OK );
	return TIU_ERROR;
  }
  // MessageBox( NULL, "{^ǉ܂B", "", MB_OK );
  hWndBtn = CreateWindow( "BUTTON",            // EBhENX
				"tiuButton",         // LvV
				WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,  // EBhEX^C
				50,                 // ʒu
				50,                 // ʒu
				100,                  // 
				50,                  // 
				hWnd,                // eEBhEnh
				(HMENU)1234,          // \[Xpԍ, ɂ邱ƂB
				(HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE),
				NULL);
  if( hWndBtn == NULL ) {
	// MessageBox( hWnd, "{^pEBhEnhNULLłB", "", MB_OK );
	return TIU_ERROR;
  }
  // tHg̕ύX
  SendMessage( hWndBtn,       // EBhEnh
               WM_SETFONT,    // tHgݒ
               (WPARAM)hFontDefault,  // tHg
               MAKELPARAM(TRUE, 0) );        // ĕ`=yes
  UpdateWindow( hWnd );
  return TIU_OK;
}
